
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>asp.net学习之ado.net（连接模式访问） / iVAN</title>

    <meta name="description" content="asp.net学习之ado.net（连接模式访问） 原文:asp.net学习之ado.net(连接模式访问)    ado.net框架支持两种模式的数据访问: 连接模式(Connected)和非连接模式(disconnected).这一节介绍如何使用连接模式访问数据库中的数据,利用ADO.NET中的Connection,Command,DataReader来获取和修改数据库中的数据 1. 连接模式的数据访问      连接模式要使用到的三个核心类:      ● IDBConnection : 表示数据源的连接,所有Connection类的基类">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">asp.net学习之ado.net（连接模式访问）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/shipfi/archive/2009/10/21/1587583.html" rel="external nofollow noreferrer">asp.net学习之ado.net（连接模式访问）</a><br />
<br />   ado.net框架支持两种模式的数据访问： 连接模式（Connected）和非连接模式(disconnected)。这一节介绍如何使用连接模式访问数据库中的数据，利用ADO.NET中的Connection,Command,DataReader来获取和修改数据库中的数据</p>
<h4>1. 连接模式的数据访问</h4>
<p>     连接模式要使用到的三个核心类：      <br />     ● IDBConnection : 表示数据源的连接,所有Connection类的基类       <br />        SqlConnection实现了IDBConnection接口，用来与SQL Server数据源进行连接       <br />     ● DBCommand  : 表示所有Command类的基类       <br />        SqlCommand实现了IDBCommand接口，与来对SQL Server数据库执行的一个 Transact-SQL 语句或存储过程       <br />     ● DataReader : 所有DataReader类的基类       <br />        SqlDataReader实现了IDataReader接口，提供一种从 SQL Server 数据库读取行的只进流的方式。       <br />     如果要连接到微软SQL Server数据库，尽量使用SqlClient命名空间中的SqlConnection,SqlCommand,SqlDataReader类，如果与Oracle数据库通信，应该使用OracleClient命名空间的类；与其它数据库进行通信，就应该使用OleDB或ODBC命名空间的类。       <br />图1: DbConnection与DbCommand的关系图如下所示:     <br /><a href="http://images.cnblogs.com/cnblogs_com/shipfi/WindowsLiveWriter/asp.netado.net_EE5F/conn_comm_rel_2.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hOGVhYzRhYzViOGQ0MmQ4ODdhNTBkZDBjNzE3ZGU1MC5qcGc=.jpg"></a></p>
<p>例1: 一个简单的连接数据库查询的例子       <br />=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code      <br />namespace  DawnDataObject        <br />{         <br />    public class Movies  // 数据实体对象        <br />    {        <br />        public static readonly string _connectionString;  // 连接数据库字符串为静态成员，每个实例共享。</p>
<p>        static Movies(){        <br />            _connectionString = WebConfigurationManager.ConnectionStrings["DawnEnterpriseDBConnectionString"].        <br />                ConnectionString;         <br />        }</p>
<p>        private string _title;        <br />        private string _director;</p>
<p>        // Movies类中包括的属性有Title、Director        <br />        public string Title{        <br />            get { return _title; }        <br />            set { _title = value; }        <br />        }         <br />        public string Director {        <br />            get { return _director; }        <br />            set { _director = value; }        <br />        }</p>
<p>        // Movies类中的GetAll方法返回一个List对象，该对象可以被GridView等控件做为数据源绑定        <br />        public List&lt;Movies&gt; GetAll()        <br />        {         <br />            List&lt;Movies&gt; result = new List&lt;Movies&gt;();        <br />            SqlConnection conn = new SqlConnection(_connectionString);        <br />            SqlCommand comm = new SqlCommand("select Title,Director from Movies", conn);        <br />            using(conn){  // using关键字指定了conn一旦离开这个代码段，自动调用其Dispose函数        <br />                conn.Open();        <br />                SqlDataReader reader = comm.ExecuteReader();        <br />                while(reader.Read()){        <br />                    Movies newmovie = new Movies();        <br />                    newmovie._title = (string)reader["Title"];        <br />                    newmovie._director = (string)reader["Director"];        <br />                    result.Add(newmovie);         <br />                }         <br />                return result;        <br />            }         <br />        }         <br />    }         <br />}</p>
<p>=== Movies.aspx ===</p>
<p>&lt;asp:GridView ID="GridView1" runat="server" DataSourceID="ObjectDataSource1" /&gt;      <br />&lt;asp:ObjectDataSource ID="ObjectDataSource1" TypeName="DawnDataObject.Movies" SelectMethod="GetAll" runat="server" /&gt;</p>
<h4>2. 使用Connection对象</h4>
<p>   Connection对象表示数据源的连接，实例化Connection对象时，需要向构造函数传递一个连接字符串。连接字符串包含了连接到数据源所需要的位置和安全认证信息      <br />   Connection对象也提供了相应的方法对数据库进行打开和关闭操作；提供了相应的属性确认数据库的状态。</p>
<p>   <strong>2.1 连接字符串</strong>       <br />        一个最普通的连接字符串如下所示：</p>
<p>    string _connectionString = "Data Source=(LOCAL);Initial Catalog=DawnEnterpriseDB;User ID=sa;Password=*****";      <br />    SqlConnection conn = new SqlConnection(_connectionSring);   // 可以在建立SqlConnection对象时把连接字符串传递给构造参数</p>
<p>       也可以使用Connection对象的ConnectionString属性来获取或设置用于打开 SQL Server 数据库的字符串</p>
<p>    string connString = conn.ConnectionString;      <br />    conn.ConnectionString = "Persist Security Info=False;Integrated Security=true;Initial Catalog=Northwind;server=(local)";</p>
<p>       ado.net提供了相应的DbConnectionStringBuilder类来管理数据库连接字符串。相对应的，sqlClient命名空间中就包含了一个SqlConnectionStringBuilder类。      <br />例2:使用SqlConnectionStringBuilder类管理数据库连接字符串</p>
<p>SqlConnectionStringBuilder connstrBuilder = new SqlConnectionStringBuilder();      <br />connstrBuilder.DataSource = "(local)";      <br />connstrBuilder.InitialCatalog = "Test";      <br />connstrBuilder.IntegratedSecurity = true;      <br />using(SqlConnection testConn = new SqlConnection(connstrBuilder.toString()))      <br />{       <br />        testConn.open();       <br />        if (testConnection.State == ConnectionState.Open) {      <br />             Console.WriteLine("Connection successfully opened");      <br />        }       <br />}</p>
<p>       可以把ConnectionString保存在Web.config文件中，然后在程序中使用WebConfigurationManager类进行读取</p>
<p>&lt;configuration&gt;      <br />    &lt;add connectionString="Data Source=.;Initial Catalog=DawnEnterpriseDB;User ID=sa;Password=******" name="DawnEnterpriseDBConnectionString" providerName="System.Data.SqlClient" /&gt;      <br />&lt;/configuration&gt;</p>
<p>       如何读取其中连接字符串的话在例1中有示例</p>
<p>    <strong>2.2 IDbConnection的共通行为与属性        <br /></strong>         因为相关的SqlConnection,OracleConnection,OleDBConnection与ODBCConnection都要实现IDBConnection接口，该接口规定了Connection类必须实现的一些行为和属性       <br />         2.2.1: 相关方法       <br />             ● BeginTransaction() : 开始数据库事务。       <br />             ● ChangeDatabase(string database) : 更改当前数据库。       <br />             ● Open() : 打开一个数据库连接，其设置由提供程序特定的 Connection 对象的 ConnectionString 属性指定       <br />             ● Close() : 关闭数据库连接       <br />             ● Dispose() : 法关闭或释放由实现此接口的类的实例保持的文件、流和句柄等非托管资源。       <br />             ● CreateCommand(): 创建并返回一个与该连接相关联的 Command 对象。       <br />         2.2.2: 相关属性       <br />             ● 包括ConnectionString、ConnectionTimeout、Database、Sate属性       <br />             以上，state属性返回的是一个ConnectionState枚举对象，其中比较常用的的状态值ConnectionState.Closed与ConnectionState.Open</p>
<p>    <strong>2.3 SqlConnection的一些其它特性</strong>       <br />         2.3.1 使用RetrieveStatistics()方法获得数据命令执行时的统计信息，例如，可以获取总命令执行时间的统计信息。       <br />                 统计信息有以下常用属性可以获得：       <br />                  ●   BytesReceived : 查询中接收到的字节数       <br />                  ●   BytesSend : 发送出数据的字节数       <br />                  ●   ConnectionTime : 当前连接被开启的总时间       <br />                  ●   ExecutionTime : 返回以毫秒为单位的连接执行时间       <br />                  ●   IduCount: 用于返回被执行Insert、Update、Delete命令的次数       <br />                  ●   IduRows : 用于返回被执行Insert、Update、Delete命令的行数       <br />                  ●   SelectCount: 用于返回Select命令执行的次数       <br />                  ●   SelectRows : 用于返回Select命令执行的行数       <br />                  ●   …       <br />例3: 取得数据库查询的执行时间       <br />=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code      <br />// Movies类中的GetAll方法返回一个List对象，该对象可以被GridView等控件做为数据源绑定        <br />namespace  DawnDataObject        <br />{         <br />    public class Movies        <br />    {         <br />        public static readonly string _connectionString;  // 连接数据库字符串为静态成员，每个实例共享。</p>
<p>        static Movies(){        <br />            _connectionString = WebConfigurationManager.ConnectionStrings["DawnEnterpriseDBConnectionString"].        <br />                ConnectionString;         <br />        }</p>
<p>        private string _title;        <br />        private string _director;</p>
<p>        // Movies类中包括的属性有Title、Director        <br />        public string Title{        <br />            get { return _title; }        <br />            set { _title = value; }        <br />        }         <br />        public string Director {        <br />            get { return _director; }        <br />            set { _director = value; }        <br />        }</p>
<p>        // Movies类中的GetAll方法返回一个List对象，该对象可以被GridView等控件做为数据源绑定        <br />        public List&lt;Movies&gt; GetAll(out long executeTime)  // executeTime作为out参数        <br />        {        <br />            List&lt;Movies&gt; result = new List&lt;Movies&gt;();        <br />            SqlConnection conn = new SqlConnection(_connectionString);        <br />            SqlCommand comm = new SqlCommand("WAITFOR DELAY '0:0:03';select Title,Director from Movies", conn);        <br />            conn.StatisticsEnabled = true;   // 开启获取统计信息的功能        <br />            using(conn){  // using关键字指定了conn一旦离开这个代码段，自动调用其Dispose函数        <br />                conn.Open();        <br />                SqlDataReader reader = comm.ExecuteReader();        <br />                while(reader.Read()){        <br />                    Movies newmovie = new Movies();        <br />                    newmovie._title = (string)reader["Title"];        <br />                    newmovie._director = (string)reader["Director"];        <br />                    result.Add(newmovie);         <br />                }         <br />                IDictionary stats = conn.RetrieveStatistics();        <br />                executeTime = (long)stats["ExecutionTime"];        <br />                return result;        <br />            }         <br />        }</p>
<p>    }         <br />}</p>
<p>=== Movies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code      <br />&lt;script runat=”server”&gt;        <br />protected void ObjectDataSource1_Selected(object sender, ObjectDataSourceStatusEventArgs e)        <br />{         <br />    Label1.Text = e.OutputParameters["executeTime"].ToString();  // 取得返回参数值        <br />}        <br />&lt;/script&gt;</p>
<p>&lt;asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="false" DataSourceID="ObjectDataSource1"&gt;        <br />&lt;asp:ObjectDataSource ID="ObjectDataSource1" TypeName="DawnDataObject.Movies"  <br />    SelectMethod="GetAll" runat="server" onselected="ObjectDataSource1_Selected"&gt;        <br />    &lt;SelectParameters&gt;        <br />        &lt;asp:Parameter Name="executeTime" DbType="Int64" Direction="Output" /&gt; &lt;!-- 获得GetAll的返回参数 --&gt;        <br />    &lt;/SelectParameters&gt;        <br />&lt;/asp:ObjectDataSource&gt;        <br />&lt;asp:Label ID="Label1" runat="server" Text="Label"&gt;&lt;/asp:Label&gt;</p>
<p>         2.3.2 使用连接池       <br />             数据库连接是非常昂贵的资源，如果希望ASP.NET应用程序处理大量用户请求的能力，使用连接池将会获得更好的效率       <br />             因为打开数据库是一件很耗时的操作，每次使用数据库时去建立连接效率将会很低，更好的办法是创建一个缓存池存放被重复使用的数据库连接。       <br />             当使用SqlConnection时，连接时是默认开启的，可以在连接字符串中使用Pooling=false将连接池关闭。       <br />             关于连接池，必须注意二件事情：1.利用连接池时，调用SqlConnection.Close()方法关闭连接仍然非常重要。不显示关闭，当前正在使用的连接就不会被放入连接池中。2.系统会跟据连接字符串的不同（使用字符串逐字比较方法），分别创建不同的连接池。因此，将连接字符串存放在站点配置文件中，尽量不要在组件代码中硬编码连接字符串。       <br />             ●  清空连接池       <br />                ClearAllPools() : 用于清空系统中所有连接池中的数据库连接       <br />                ClearPool() : 清空第统中指定连接池里的数据库连接       <br />             ● 设置连接字符串中连接池的属性 [以上这些属性的键/值对是在ConnectionString中指定的]       <br />                Connection Timeout : 用于指定为秒为单位的连接生存最大值（默认为0，永不失效）       <br />                Connection Reset : 是否自动 重置来自连接池中的连接(默认为true)       <br />                Max Pool Size : 保存在连接池中的最大连接数(默认为100)       <br />                Min Pool Size : 保存在连接池中的最小连接数       <br />                Pooling : 是否开始连接池</p>
<p>    <strong>2.4 关闭连接 Close()与Dispose()        <br /></strong>         以上两个函数都可以关闭连接，但是它们有什么不同的。以下摘录的就是它们不同的地方：</p>
<p>• Calling Close on a connection object enables the underlying connection to be pooled.      <br />• Calling Dispose on a connection object alleviates the need for you to call Close on it explicitly. It not only ensures that       <br />the underlying connection can be pooled, but it also makes sure that allocated resources can now be garbage collected.       <br />• Not calling either Close or Dispose will effectively kill your application performance by increasing the connection pool to a maximum limit,       <br />and then everyone will have to wait for the next available connection object. Not only that, but even when the open connections fall out of scope,       <br />they won’t be garbage collected for a relatively long time because the connection object itself doesn’t occupy that much memory—and the lack of memory       <br />is the sole criterion for the garbage collector to kick in and do its work.       <br />  In short, Dispose is the best option as it helps garbage collection and connection pooling, Close is second best option as it helps only connection pooling,       <br />and not calling either Close or Dispose is so bad that you shouldn’t even go there.</p>
<h4>3. Command对象</h4>
<p>    Command对象表示一个可以对数据源执行的命令。在这里主要介绍的是SqlCommand对象，SqlCommand继承自Command对象的公共基类DBCommand。        <br />    <strong>3.1 SQL或存储过程 命令的执行</strong>         <br />       可以通过SqlCommand.ExecuteNonQuery方法来执行一个SQL命令，该方法不会返回任何一个结果集。这个方法通常用来执行SQL语句中的Update、Insert、Delete命令。         <br />       当然也可以用来执行如Create Table，Drop DataBase命令等         <br />例4: 使用SqlCommand更新和删除电影记录的方法UpdateMovie和DeleteMovie()         <br />=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />namespace  DawnDataObject       <br />{        <br />    public class Movies       <br />    {        <br />        public static readonly string _connectionString;  // 连接数据库字符串为静态成员，每个实例共享。</p>
<p>        static Movies(){       <br />            _connectionString = WebConfigurationManager.ConnectionStrings["DawnEnterpriseDBConnectionString"].       <br />                ConnectionString;        <br />        }</p>
<p>        private string _title;       <br />        private string _director;       <br />        private Int32 _id;</p>
<p>        // Movies类中包括的属性有Title、Director       <br />        public string Title{       <br />            get { return _title; }       <br />            set { _title = value; }       <br />        }        <br />        public string Director {       <br />            get { return _director; }       <br />            set { _director = value; }       <br />        }        <br />        public Int32 Id {       <br />            get { return _id; }       <br />        }</p>
<p>        // Movies类中的GetAll方法返回一个List对象，该对象可以被GridView等控件做为数据源绑定       <br />        public List&lt;Movies&gt; GetAll(out long executeTime)  // executeTime作为out参数       <br />        {       <br />            List&lt;Movies&gt; result = new List&lt;Movies&gt;();       <br />            SqlConnection conn = new SqlConnection(_connectionString);       <br />            SqlCommand comm = new SqlCommand("select Id,Title,Director from Movies", conn);       <br />            conn.StatisticsEnabled = true;       <br />            using(conn){  // using关键字指定了conn一旦离开这个代码段，自动调用其Dispose函数       <br />                conn.Open();       <br />                SqlDataReader reader = comm.ExecuteReader();       <br />                while(reader.Read()){       <br />                    Movies newmovie = new Movies();       <br />                    newmovie._title = (string)reader["Title"];       <br />                    newmovie._director = (string)reader["Director"];       <br />                    newmovie._id = (Int32)reader["Id"];       <br />                    result.Add(newmovie);        <br />                }        <br />                IDictionary stats = conn.RetrieveStatistics();       <br />                executeTime = (long)stats["ExecutionTime"];       <br />                return result;       <br />            }        <br />        }</p>
<p>        // 对Movies表进行更新的方法       <br />        public void UpdateMovie(int id,string title,string director)       <br />        {        <br />            SqlConnection conn = new SqlConnection(_connectionString);       <br />            SqlCommand command = conn.CreateCommand();  // 使用SqlConnection.CreateCommand获得SqlCommand对象       <br />            command.CommandText = "Update Movies set Title=@title,Director=@director where Id=@id";       <br />            command.Parameters.AddWithValue("@id", id);       <br />            command.Parameters.AddWithValue("@title", title);       <br />            command.Parameters.AddWithValue("@director", director);       <br />            using(conn){       <br />                conn.Open();        <br />                command.ExecuteNonQuery();        <br />            }        <br />        }</p>
<p>        // 对Movies表进行删除的方法       <br />        public void DeleteMovie(int id)       <br />        {        <br />            SqlConnection conn = new SqlConnection(_connectionString);       <br />            // 使用new SqlCommand获得SqlCommand对象       <br />            SqlCommand command = new SqlCommand("delete from Movies where Id=@id",conn);       <br />            command.Parameters.AddWithValue("@id", id);       <br />            using(conn)       <br />            {        <br />                conn.Open();        <br />                command.ExecuteNonQuery();        <br />            }        <br />        }</p>
<p>    }        <br />}</p>
<p>=== Movies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;asp:GridView ID="GridView1" runat="server" DataKeyNames="Id"       <br />    AutoGenerateColumns="False" DataSourceID="ObjectDataSource1"       <br />            onrowcommand="GridView1_RowCommand" onrowdeleting="GridView1_RowDeleting"       <br />            AllowPaging="True" &gt;       <br />&lt;Columns&gt;       <br />    &lt;asp:BoundField HeaderText="Id" DataField="Id" Visible="false" /&gt;       <br />    &lt;asp:BoundField HeaderText="Title" DataField="Title" /&gt;       <br />    &lt;asp:BoundField HeaderText="Director" DataField="Director" /&gt;       <br />    &lt;asp:CommandField ShowEditButton="True" /&gt;       <br />    &lt;asp:CommandField ShowDeleteButton="True" /&gt;       <br />&lt;/Columns&gt;       <br />&lt;/asp:GridView&gt;       <br />&lt;asp:ObjectDataSource ID="ObjectDataSource1" TypeName="DawnDataObject.Movies"       <br />    SelectMethod="GetAll" UpdateMethod="UpdateMovie" DeleteMethod="DeleteMovie" runat="server" onselected="ObjectDataSource1_Selected"&gt;       <br />    &lt;SelectParameters&gt;       <br />        &lt;asp:Parameter Name="executeTime" DbType="Int64" Direction="Output" /&gt;       <br />    &lt;/SelectParameters&gt;       <br />    &lt;UpdateParameters&gt;       <br />        &lt;asp:Parameter Name="Id" DbType="Int32" /&gt;       <br />        &lt;asp:Parameter Name="Title" DbType="String" /&gt;       <br />        &lt;asp:Parameter Name="Director" DbType="String" /&gt;       <br />    &lt;/UpdateParameters&gt;       <br />    &lt;DeleteParameters&gt;       <br />        &lt;asp:Parameter Name="Id" DbType="Int32" /&gt;       <br />    &lt;/DeleteParameters&gt;       <br />&lt;/asp:ObjectDataSource&gt;</p>
<p> </p>
<p>    <strong>3.2 执行带参数的命令        <br /></strong>        大多数SQL命令都带有参数，比如在执行对数据库记录更新时，就要提供参数表示数据记录项的新值       <br />        最好不要通过手工串接+=操作来构建SQL命令参数，因为这样很容易遭受SQL注入攻击。       <br />        而使用SqlParameter对象来表示参数有很多种构建方式，最简单的就像下面一样来调用 SqlCommand.AddWithValue()方法</p>
<p>SqlCommand cmd = new SqlCommand("Insert Title(Title) values(@title)",conn);  // 注意，@title就算为字符串类型也不需要用''括起来     <br />cmd.Parameters.AddWithValue("@title",”ASP.NET 2.0");</p>
<p>           当使用AddWithValue()方法时，SqlCommand自动识别并推测参数的类型和大小。该方法会假设字符串值类型为NVarChar, 整数值类型为Int,十进行数值类型为Decimal,以此类推。      <br />           另一种构建参数的方法是直接创建SqlParameter对象，并加入到SqlCommand对象中。这样做的好处是：可以显式指定参数名称，大小，精度，刻度和传递方向。</p>
<p>SqlCommand cmd = new SqlCommand("Insert Title(Title) values(@title)",conn);     <br />SqlParameter paramTitle = new SqlParameter();     <br />paramTitle.ParameterName = "@Title";     <br />paramTitle.SqlDbType = SqlDbType.NVarChar;     <br />paramTitle.Size = 50;     <br />paramTitle.Value = "ASP.NET";     <br />cmd.Parameters.Add(paramTitle);</p>
<p>           第三种方法，直接使用Add的一个重载方法来创建新的SqlParameter对象</p>
<p>SqlCommand cmd = new SqlCommand("Insert Title(Title) values(@title)",conn);     <br />cmd.Parameters.Add("@Title",SqlDbType.NVarChar,50).Value = "ASP.NET";</p>
<p>           以上，使用第一种方法比较简便，直观。     <br />图2: Command与Parameters的关系图如下所示：      <br /><a href="http://images.cnblogs.com/cnblogs_com/shipfi/WindowsLiveWriter/asp.netado.net_EE5F/comm_params_2.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xMzE1NGNkMTExODc3NGY3MDFiMWM4NzI1ZjdjZTcyMC5qcGc=.jpg"></a>  </p>
<p>    <strong>3.3 执行存储过程</strong>       <br />        SqlCommand对象可以用来执行存储过程 ，执行存储过程如下所示：       <br />SqlCommand cmd = new SqlCommand("GetTitles",conn);       <br />cmd.CommandType = CommandType.StoredProcedure;       <br />        在SqlCommand的第一个参数中，不要把参数放到里面去，只要放存储过程名就行了，参数在SqlCommand的SqlParameters对象中添加       <br />例5: 使用存储过程而非SQL语句更新电影信息记录       <br />=== 存储过程创建 ===</p>
<p>create procedure UpdateMovie     <br />(      <br />    @id int,     <br />    @title varchar(255),     <br />    @director varchar(255)     <br />)      <br />as     <br />    update movies set title=@title,director=@director where id=@id</p>
<p>=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />// 只要变更例4中的UpdateMovie函数，其它代码不变       <br />public void UpdateMovie(int id,string title,string director)       <br />{        <br />    SqlConnection conn = new SqlConnection(_connectionString);       <br />    SqlCommand command = conn.CreateCommand();  // 使用SqlConnection.CreateCommand获得SqlCommand对象       <br />    // 与例4相比，只要变更下面两句       <br />    command.CommandText = "UpdateMovie";    <br />    command.CommandType = CommandType.StoredProcedure;       <br />    command.Parameters.AddWithValue("@id", id);       <br />    command.Parameters.AddWithValue("@title", title);       <br />    command.Parameters.AddWithValue("@director", director);       <br />    using(conn){       <br />        conn.Open();        <br />        command.ExecuteNonQuery();        <br />    }        <br />}</p>
<p>        存储过程可以有返回值(returnvalue)，也可以有输出参数(output),那么，作为程序，如何调用存储过程后，取得相应的返回值呢。      <br />例6: 从存储过程中取得返回值       <br />=== SelectMovies存储过程 ===</p>
<p>CREATE PROCEDURE dbo.GetMovieCount     <br />AS     <br />RETURN (SELECT COUNT(*) FROM Movies)</p>
<p>=== movies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;script runat="server"&gt;       <br />void Page_Load()       <br />{        <br />    lblMovieCount.Text = GetMovieCount().ToString();       <br />}        <br />private int GetMovieCount()       <br />{        <br />    int result = 0;       <br />    string connectionString = WebConfigurationManager.connectionString["Movies"].ConnectionString;       <br />    SqlConnection con = new SqlConnection(connectionString);       <br />    SqlCommand cmd = new SqlCommand("GetMovieCount", con);       <br />    cmd.CommandType = CommandType.StoredProcedure;       <br />    cmd.Parameters.Add("@ReturnVal", SqlDbType.Int).Direction =ParameterDirection.ReturnValue; // 设定返回值参数       <br />    using (con)       <br />    {        <br />        con.Open();        <br />        cmd.ExecuteNonQuery();  // 好像一定要使用ExecuteNonQuery,如果使用ExecuteReader，则相应的返回值就取不出来。       <br />        result = (int)cmd.Parameters["@ReturnVal"].Value;  // 取得返回值参数值       <br />    }       <br />    return result;       <br />}        <br />&lt;/script&gt;<br />
<br /> 例7: 从存储过程中取得OUTPUT值     <br />=== 存储过程创建 ===</p>
<p>CREATE PROCEDURE dbo.GetBoxOfficeTotals     <br />(      <br />    @SumBoxOfficeTotals Money OUTPUT     <br />)      <br />AS     <br />SELECT @SumBoxOfficeTotals = SUM(BoxOfficeTotals) FROM Movies</p>
<p>=== movies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;script runat=server&gt;       <br />public List&lt;Movie5&gt; GetBoxOffice(out decimal SumBoxOfficeTotals)       <br />{        <br />    List&lt;Movie5&gt; results = new List&lt;Movie5&gt;();       <br />    SqlConnection con = new SqlConnection(_connectionString);       <br />    SqlCommand cmd = new SqlCommand("GetBoxOfficeTotals", con);       <br />    cmd.CommandType = CommandType.StoredProcedure;       <br />    cmd.Parameters.Add("@SumBoxOfficeTotals", SqlDbType.Money).Direction = ParameterDirection.Output;       <br />    using (con)        <br />    {        <br />        con.Open();        <br />        SqlDataReader reader = cmd.ExecuteReader();  // 使用OUTPUT参数，可以使用ExecuteReader。与ReturnValue不同。       <br />        while (reader.Read())       <br />        {        <br />            Movie5 newMovie = new Movie5();       <br />            newMovie.Title = (string)reader["Title"];       <br />            newMovie.BoxOfficeTotals = (decimal)reader["BoxOfficeTotals"];       <br />            results.Add(newMovie);        <br />        }        <br />    reader.Close();        <br />    SumBoxOfficeTotals = (decimal)cmd.Parameters["@SumBoxOfficeTotals"].       <br />    Value;        <br />    }        <br />    return results;       <br />}        <br />&lt;/script&gt;</p>
<p>    <strong>3.4 单一的返回值</strong>       <br />       如果需要从数据库查询中获取单一的返回值，可以使用SqlCommand.ExecuteScalar()方法。该方法总是返回查询结果集中第一行第一列的数据值。       <br />       ExecuteScalar方法返回值的类型为object,可以将它转换为想要的类型。</p>
<p>    <strong>3.5 返回结果集</strong>       <br />       在例1、例3、例4中，利用了SqlCommand.ExecuteReader()方法，调用这个方法将返回一个SqlDataReader对象，我们使用该对象读取每一行数据，并将数据存入一个泛型集合(List&lt;Movie&gt;)中,       <br />       如果希望省略复制步骤，并且不把获取的记录存入集合对象中，那么这里需要向ExecuteReader方法传递一个CommandBehavior.CloseConnection参数，该参数会使数据库连接与SqlDataReader对象关联起来，当从SqlDataReader对象中<strong>读取了所有的数据记录</strong>后。连接将自动关闭。       <br />       默认的向ExecuteReader方法传递一个CommandBehavior.Default参数，它表示此查询<strong>可能返回多个结果集</strong>。执行查询可能会影响数据库状态。调用SqlCommand.ExecuteReader(CommandBehavior.Default)就相当于调用SqlCommand.ExecuteReader()       <br />例8: 不使用泛型集合作数据源       <br />=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />namespace  DawnDataObject       <br />{        <br />    public class Movies       <br />    {        <br />        public SqlDataReader GetDataReader()       <br />        {        <br />            SqlConnection conn = new SqlConnection(_connectionString);       <br />            SqlCommand command = new SqlCommand("SelectMovies", conn);       <br />            command.CommandType = CommandType.StoredProcedure;       <br />            conn.Open();        <br />            return command.ExecuteReader(CommandBehavior.CloseConnection);  // 直接返回DataReader作为数据源       <br />        }       <br />       <br />        public void UpdateMovies() {…}       <br />        public void DeleteMovies() {…}       <br />    }        <br />}</p>
<p>=== movies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;!-- 因为DataReader的原因,这里的GridView不支持分页,排序 --&gt;       <br />&lt;asp:GridView ID="GridView1" runat="server" DataKeyNames="Id"       <br />            AutoGenerateColumns="False" DataSourceID="ObjectDataSource1"       <br />            onrowcommand="GridView1_RowCommand" onrowdeleting="GridView1_RowDeleting" &gt;       <br />&lt;Columns&gt;       <br />    &lt;asp:BoundField HeaderText="Id" DataField="Id" Visible="false" /&gt;       <br />    &lt;asp:BoundField HeaderText="Title" DataField="Title" /&gt;       <br />    &lt;asp:BoundField HeaderText="Director" DataField="Director" /&gt;       <br />    &lt;asp:CommandField ShowEditButton="True" /&gt;       <br />    &lt;asp:CommandField ShowDeleteButton="True" /&gt;       <br />&lt;/Columns&gt;       <br />&lt;asp:ObjectDataSource ID="ObjectDataSource1" TypeName="DawnDataObject.Movies"       <br />    SelectMethod="GetDataReader" UpdateMethod="UpdateMovie" DeleteMethod="DeleteMovie" runat="server" &gt;       <br />    &lt;UpdateParameters&gt;       <br />        &lt;asp:Parameter Name="Id" DbType="Int32" /&gt;       <br />        &lt;asp:Parameter Name="Title" DbType="String" /&gt;       <br />        &lt;asp:Parameter Name="Director" DbType="String" /&gt;       <br />    &lt;/UpdateParameters&gt;       <br />    &lt;DeleteParameters&gt;       <br />        &lt;asp:Parameter Name="Id" DbType="Int32" /&gt;       <br />    &lt;/DeleteParameters&gt;       <br />&lt;/asp:ObjectDataSource&gt;  <br />
<br /> <br />
<h4>4. DataReader对象</h4>
<p>    DataReader对象可以用来表示数据库查询的结果。该对象可以通过调用Command对象的ExecuteReader()方法获得.      <br />    调用DataReader的HasRows属性或者Read()方法，可以判断DataReader对象所表示的查询结果中是否包含数据行记录       <br />    调用Reader()方法，可以将DataReader对象所表示的当前数据行向前移动一行，移动一行后，返回true,到末尾，无法向前移动，返回false.       <br />    任意时刻上，DataReader对象只表示查询结果集中的某一行记录。  <br />图3：DataReader与Command关系如下图所示:      <br /><a href="http://images.cnblogs.com/cnblogs_com/shipfi/WindowsLiveWriter/asp.netado.net_EE5F/comm_dataReader_rel_2.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kYzBkNzVkYzA5NmQ4Y2FkODc1OTkyYWU3NDA1ZmY0Ny5qcGc=.jpg"></a></p>
<p>    4<strong>.1 获得DataReader对象中数据行的字段值</strong>       <br />         如果要获得当前行中相应的字段值，可以使用以下方法来获得：       <br />         ● string title = (string)reader["title"];     // 通过字段名称返回Object类型，再转换       <br />         ● string title = (string)reader[0];           // 通过字段位置返回Object类型，再转换       <br />         ● string title = reader.GetString(0);       // 通过字段位置返回string类型。       <br />         ● string title = reader.GetSqlString(0);   // 通过字段位置，返回SqlString类型。       <br />  <br />     <strong>4.2 返回多个结果集        <br /></strong>         一个简单的数据库查询可以返回多个结果集，如以下SQL语句       <br />         "select * from MovieCategories; select * from movies"       <br />         在一次命令提交中执行多个查询可以提高效率，也可以避免战胜多个数据库连接。       <br />         在返回多个结果集的情况下，可以使用SqlDataReader的MoveResult()方法切换到下一个结果集中。       <br />例9:返回多个结果集       <br />=== App_Code\DawnDataObject.cs ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />namespace mulitResults       <br />{        <br />    public class DataLayer1       <br />    {        <br />        private static readonly string _connectionString;</p>
<p>        public class MovieCategory  // 表示电影种类实体,注意是嵌套类       <br />        {       <br />            private int _id;       <br />            private string _name;       <br />            public int Id       <br />            {        <br />                get { return _id; }       <br />                set { _id = value; }       <br />            }        <br />            public string Name       <br />            {        <br />                get { return _name; }       <br />                set { _name = value; }       <br />            }        <br />        }</p>
<p>        public class Movie  // 表示电影实体,注意是嵌套类       <br />        {       <br />            private string _title;       <br />            private int _categoryId;       <br />            public string Title       <br />            {        <br />                get { return _title; }       <br />                set { _title = value; }       <br />            }        <br />            public int CategoryId       <br />            {        <br />                get { return _categoryId; }       <br />                set { _categoryId = value; }       <br />            }        <br />        }</p>
<p>        // 不像刚才实体列表作为返回值反回,现在作为参数返回       <br />        public static void GetMovieData(List&lt;DataLayer1.MovieCategory&gt; movieCategories,List&lt;DataLayer1.Movie&gt; movies)       <br />        {        <br />            string commandText = "SELECT Id,Name FROM MovieCategories;SELECT Title,CategoryId FROM Movies";       <br />            SqlConnection con = new SqlConnection(_connectionString);       <br />            SqlCommand cmd = new SqlCommand(commandText, con);       <br />            using (con)       <br />            {        <br />                // Execute command       <br />                con.Open();       <br />                SqlDataReader reader = cmd.ExecuteReader();       <br />                // Create movie categories       <br />                while (reader.Read())       <br />                {        <br />                    DataLayer1.MovieCategory newCategory = new DataLayer1.       <br />                    MovieCategory();        <br />                    newCategory.Id = (int)reader["Id"];       <br />                    newCategory.Name = (string)reader["Name"];       <br />                    movieCategories.Add(newCategory);        <br />                }        <br />                // Move to next result set       <br />                reader.NextResult();       <br />                // Create movies       <br />                while (reader.Read())       <br />                {        <br />                    DataLayer1.Movie newMovie = new DataLayer1.Movie();       <br />                    newMovie.Title = (string)reader["Title"];       <br />                    newMovie.CategoryId = (int)reader["CategoryID"];       <br />                    movies.Add(newMovie);        <br />                }        <br />            }        <br />        }        <br />        static DataLayer1()       <br />        {        <br />            _connectionString = WebConfigurationManager.ConnectionStrings["Movies"].ConnectionString;       <br />        }        <br />    }        <br />}</p>
<p>=== ShowMovies.aspx ===</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;script runat="server"&gt;       <br />void Page_Load()       <br />{        <br />    // Get database data       <br />    List&lt;DataLayer1.MovieCategory&gt; categories = new List&lt;DataLayer1.MovieCategory&gt;();       <br />    List&lt;DataLayer1.Movie&gt; movies = new List&lt;DataLayer1.Movie&gt;();       <br />    DataLayer1.GetMovieData(categories, movies);        <br />    // Bind the data       <br />    grdCategories.DataSource = categories;       <br />    grdCategories.DataBind();        <br />    grdMovies.DataSource = movies;       <br />    grdMovies.DataBind();        <br />}        <br />&lt;/script&gt;       <br />&lt;h1&gt;Movie Categories&lt;/h1&gt;       <br />&lt;asp:GridView id="grdCategories" Runat="server" /&gt;       <br />&lt;h1&gt;Movies&lt;/h1&gt;       <br />&lt;asp:GridView id="grdMovies" Runat="server" /&gt;</p>
<p>    <strong>4.3 多活动结果集MARS (Multiple Active Resultsets)</strong>       <br />        ADO.NET 2.0提供了MARS的新特性，在以前版本的ADO.NET中，数据库连接在一个有限时间段内能且只能表示一个查询结果集。       <br />        利用MARS特性，可以使用单一的数据库连接表示多个查询结果集。       <br />        MARS在以下场景中很有价值：程序对一个结果集遍历的过程中，同时需要对当前结果集中的记录执行一些额外的数据库操作。       <br />        打开MARS功能，需要在连接字符口串中包含以下字段: MultipleActiveResultSets=True;       <br />例10: 使用多个结果集</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xYzUzNjY4YmNlZTM5M2VkYWMwZDdiM2IzZGFmZjFhZS5naWY=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180MDViMThiNGI2NTg0YWUzMzhlMGY2ZWNhZjczNjUzMy5naWY=.jpg">Code     <br />&lt;script runat=”server”&gt;       <br />void BuildTree()       <br />{        <br />    // Create MARS connection       <br />    SqlConnection con = new SqlConnection(_connectionString);       <br />    // Create Movie Categories command       <br />    string cmdCategoriesText = "SELECT Id,Name FROM MovieCategories";       <br />    SqlCommand cmdCategories = new SqlCommand(cmdCategoriesText, con);       <br />    // Create Movie command       <br />    string cmdMoviesText = "SELECT Title FROM Movies " + "WHERE CategoryId=@CategoryID";       <br />    SqlCommand cmdMovies = new SqlCommand(cmdMoviesText, con);       <br />    cmdMovies.Parameters.Add("@CategoryId", SqlDbType.Int);       <br />    using (con)        <br />    {        <br />        con.Open();        <br />        // 打开一个结果集,表示电影目录       <br />        SqlDataReader categories = cmdCategories.ExecuteReader();       <br />        while (categories.Read())       <br />        {        <br />            // Add category node       <br />            int id = categories.GetInt32(0);       <br />            string name = categories.GetString(1);       <br />            TreeNode catNode = new TreeNode(name);       <br />            TreeView1.Nodes.Add(catNode);        <br />            // Iterate through matching movies       <br />            cmdMovies.Parameters["@CategoryId"].Value = id;       <br />            SqlDataReader movies = cmdMovies.ExecuteReader();  // 打开另一个结果集.注:上一个结果集还没有被关闭.       <br />            while (movies.Read())       <br />            {        <br />                // Add movie node       <br />                string title = movies.GetString(0);       <br />                TreeNode movieNode = new TreeNode(title);       <br />                catNode.ChildNodes.Add(movieNode);        <br />            }        <br />            movies.Close();        <br />    }        <br />}        <br />void Page_Load()       <br />{        <br />    if (!Page.IsPostBack)       <br />        BuildTree();        <br />}        <br />&lt;/script&gt;</p>
<p>&lt;asp:TreeView id=”TreeView1” Runat=”server” /&gt;</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 01:23:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/asp/" title="asp">asp</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>asp.net学习之ado.net（连接模式访问）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rq1mz.html" rel="bookmark">ASP&period;NET MVC 5 学习教程：创建连接字符串</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 ASP.NET MVC 5 学习教程:创建连接字符串 起飞网 ASP.NET MVC 5 学习教程目录: 添加控制器 添加视图 修改视图和布局页 控制器传递数据给视图 添加模型 创建连接字符串 通过控制器访问模型的数据 生成的代码详解 使用 SQL Server LocalDB Edit方法和Edit视图详解 添加查询 Entity Framework 数据迁移之添加字段 添加验证 Details 和 Delete 方法详解 在上一节中,我们创建了MovieDBContext 类来连接数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDAvgXb.html" rel="bookmark">ASP&period;NET学习的九大步骤详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ASP.NET学习呢首先,你需要具备OO基础,如果你已经有较多的面向对象开发经验,跳过以下这两点: ◆掌握一门.NET面向对象语言,C#或VB.NET 我强烈反对在没系统学过一门面向对象(OO)语言的前提下去学ASP.NET. ASP.NET是一个全面向对象的技术,不懂OO,那绝对学不下去! ◆对.NET Framework类库有一定的了解 可以通过开发Windows Form应用程序来学习.NET Framework.ASP.NET是建构在.NET Framework之上的技术,你对.NET			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWlGYrp.html" rel="bookmark">asp&period;net学习之GridView事件、GridViewRow对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:asp.net学习之GridView事件.GridViewRow对象 1. GridView控件的事件     GridView有很多事件,事件可以定制控件的外观或者行为.事件分为三类     1.1 GridView显示数据时的事件           ● DataBinding : 在绑定数据源之前触发 [继承自Control]           ● DataBound 在绑定到数据源后触发           ● RowCreated 创建每一行时触发           ● Ro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1rZgKp.html" rel="bookmark">asp&period;net学习之GridView七种字段</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:asp.net学习之GridView七种字段     asp.net中GridView绑定到数据源时,可以自动显示数据源的各个字段.只要设定其AutoGenerateColumns为TRUE即可.但这,自动显示有其不好的一面,因为不能自义定控制显示的样式.     解决以上的办法就是指定需要GridView显示的字段,GridView控件支持以下七种类型的Field:       ● BoundField   :  将数据项显示为文本       ● CheckBoxField : 将数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0nANmz.html" rel="bookmark">asp&period;net学习之扩展GridView</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:asp.net学习之扩展GridView    本节讨论如何从现有的控件,进而扩展成强大的,更定制的GridView控件 1.扩展BoundField        默认的BoundField不能显示多文本,文字一多,就会扩大整个Table的Height值,解决这个问题的方法可以通过TemplateField加入Div控件来解决,但是,也可以从BoundField类上进行扩展,加入一点特有的功能,让他能够显示多文本 例1: 创建长文本字段 ===App_code\myControls.cs			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL57D0z.html" rel="bookmark">asp&comma;asp&period;net学习教程下载&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				XML与ASP网站实作大全 ASP经典百例 ASP.NET 1.1专业开发 ASP.NET完全手册 ASP.NET 技术参考 ASP.netdatabase开发圣经 ASP数据库系统开发实例导航 怎样用ASP和COM进行Web编程 Asp.Net技术文档 ASP Net密技集錦(C#) 即时应用ASP脚本第二版 简单易学的ASP教程 ASP开发中的错误信息中文说明大全 10天学会ASP ASP中文使用手册 ASP.NET服务器控件高程 ASP.NET 实用全书 ASP 3.0高级编程 ASP.N			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5WJ2Ab.html" rel="bookmark">ADO&period;Net连接SQL Azure数据库详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ADO.Net连接SQL Azure数据库教程详解 在.Net环境下,连接数据库最常用的方法是使用ADO.Net.在SQL Azure环境下,ADO.Net 可以继续使用,这样对于.Net环境下的开发者来说,不用学习新的知识与技能就可以很容易 的连接到SQL Azure数据库上,这也符合微软所一直在宣传的云计算战略,减少了单独学习云 应用开发的成本. 要使用ADO.Net连接SQL Azure,有两种方法,一种是通过SQL Azure的门户管理页面提供 的连接字符串来连接;另一种方法是在程序里硬			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4mdLb.html" rel="bookmark">PHP通过ADO方式连接Access</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP通过ADO方式连接Access数据库,如下代码: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot;   &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt;  &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;  &lt;head&gt;  &			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4xXjz.html" rel="bookmark">ADO&period;NET连接池FAQ</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ado 摘要 连接池允许应用程序从连接池中获得一个连接并使用这个连接,而不需要为每一个连接请求重新建立一个连接.一旦一个新的连接被创建并且放置在连接池中,应用程序就可以重复使用这个连接而不必实施整个数据库连接创建过程. 当应用程序请求一个连接时,连接池为该应用程序分配一个连接而不是重新建立一个连接:当应用程序使用完连接后,该连接被归还给连接池而不是直接释放. 如何实现连接池 确保你每一次的连接使用相同的连接字符串(和连接池相同):只有连接字符串相同时连接池才会工作.如果连接字符串不相同,应用程序			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxooOb.html" rel="bookmark" class="title">查看Linux版本信息</a>
					<div>
						如何查看Linux系统使用的版本信息呢? 下面这篇文章收集.整理了一些常见的查看Linux系统版本的方法.由于手头只有Oracle Linux.Centos Linux.Redhat Linux三个版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6E1Wb.html" rel="bookmark" class="title">AJAX：开发者新的技术天地介绍</a>
					<div>
						ajax AJAX开发者的最新工具和技术 基于XML的异步JavaScript,简称AJAX,是当前Web创新(称为Web2.0)中的一个王冠.感谢组成AJAX的各种技术,Web应用的交互如Flick ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrEo6b.html" rel="bookmark" class="title">&lbrack;css&rsqb;简明教程 CSS样式表概述</a>
					<div>
						css|教程|样式表     CSS(Cascading Style sheets,层叠样式表)是一种制作网页的新技术,现在已经为大多数的浏览器所支持,成为网页设计必不可少的工具之一.使用CSS能够简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ8rWz.html" rel="bookmark" class="title">许金：总结会被搜索引擎惩罚的几种情况</a>
					<div>
						很多朋友在进行SEO时过于操之过急,难免会发生些意外.做SEO大部分都是靠搜索引擎来获取流量,而在中国更多依靠的是百度.经常会有被搜索引擎惩罚的情况出现,为了使更多的人少走弯路,这里罗列几点避免被搜索 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zee7jz.html" rel="bookmark" class="title">Visual Studio&period;net中的XML注释 &lpar;1&rpar;</a>
					<div>
						visual|xml Visual Studio.net中的XML注释10/18/2001 11:1:33· · ··YESKY 介绍 在这个实践练习中,你将在C#源文件中插入XML注释,然后通过C# ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A6KDp.html" rel="bookmark" class="title">利用金山词霸字库在Word中输入英语音标</a>
					<div>
						朋友们常常需要在Word文字编辑中输入英语的音标,但不知从哪里才能找到它们. 在系统默认的字体中是找不到音标的.建议你安装金山词霸,或者将金山词霸的安装盘中的\\Xdict\\ksphonet.ttf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKo8jp.html" rel="bookmark" class="title">Struts自定义标签的过程</a>
					<div>
						近日体验了一下Eclipse 打开某个jsp页面,页面上的select下拉列表框用Struts自定义标签来完成 1.新建页面:Test.jsp 2.在Web应用的WEB-INF目录下自定义标签TLD文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NmnJz.html" rel="bookmark" class="title">动感模糊独特玩法 模拟慢门打造另类风光</a>
					<div>
						  话不多说,直接正题:(因为我不保存PSD,所以很多时候做的效果可能不太一样,但是步骤就是这样哒~)教程讲解如何利用后期打造模拟慢门一样的风光照.下面是本次教程最终效果图: ACR里面的东西我这里就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2NEAb.html" rel="bookmark" class="title">XP开机蓝屏原因及解决方法</a>
					<div>
						遇到蓝屏紧急处理三条: 1.遇到的蓝屏,内存问题可能性最大(突然出现)内存条能是内存条松动或有静电.取出擦拭后重新装上或换一个插孔就可以了 2.系统兼容性的问题(新装机) 3.中了病毒,杀毒并尝试系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8e5kb.html" rel="bookmark" class="title">金山毒霸严重BUG再次导致大量Win7&sol;8用户系统崩溃</a>
					<div>
						  3月23日,我们西西接到部分用户反馈,部分64位Windows 7或Windows 8系统启动异常,经查明,是最近一次针对安全问题的更新,修改kavbootc驱动在部分系统上出现bug.目前,我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLavPvz.html" rel="bookmark" class="title">程序文件-VHDL出租车计费程序求助</a>
					<div>
						问题描述 VHDL出租车计费程序求助 求各位大神留意一下! 设计一台出租车计价器,不同情况具有不同的收费标准. 基本要求: 1.行驶公里: 用时钟 2 秒钟表示出租车匀速行驶1 公里,在行车5 公里以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRn5ep.html" rel="bookmark" class="title">iOS中Animation 动画 UI&lowbar;22</a>
					<div>
						版权声明:本文为博主原创文章,未经博主允许不得转载. 1.iOS中我们能看到的控件都是UIView的子类,比如UIButton UILabel UITextField UIImageView等等 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ2NZz.html" rel="bookmark" class="title">为什么 android Messaging 应用被启动？</a>
					<div>
						问题描述 为什么 android Messaging 应用被启动? 我查看android信息应用的源代码,manifest 文件中是这样的: &lt;intent-filter&gt; &lt;act ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZvOdb.html" rel="bookmark" class="title">link中满足相同输入的函数必然输出相同，是不是就没有副作用了？是不是可以并行调用？</a>
					<div>
						问题描述 link中满足相同输入的函数必然输出相同,是不是就没有副作用了?是不是可以并行调用? link中满足相同输入的函数必然输出相同,是不是就没有副作用了?是不是可以并行调用? 解决方案 不一定, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RY6Az.html" rel="bookmark" class="title">Facebook交换机迈向100G 以适用下一代数据中心</a>
					<div>
						Facebook宣布正在打造架顶100Gbit/s的以太网交换机,以用于其下一代数据中心上.很多大互联网公司都在设计自己的系统,务必紧随先进的计算和半导体技术的步伐. Facebook的Wedge 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkLPvM.html" rel="bookmark" class="title">maven tomcat7-maven  tomct7 deploy  报错 配置都检查了没错呀</a>
					<div>
						问题描述 maven tomct7 deploy 报错 配置都检查了没错呀 ERROR] Failed to execute goal org.apache.tomcat.maven:tomcat7- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWwn5z.html" rel="bookmark" class="title">福建铁通&OpenCurlyDoubleQuote;智控眼&rdquo;开始运营</a>
					<div>
						王文珊 本报讯 近日,福建铁通对全省&quot;智控眼&quot;系统平台进行初验,根据厂家提供的竣工资料及前期的测试结果,验收小组最终认为系统初验合格.至此,福建铁通&quot;智控眼&quot;系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2W5VM.html" rel="bookmark" class="title">OpenStack现燎原之势 成为最受欢迎开源云平台</a>
					<div>
						OpenStack正呈现燎原之势.经过几年的布道,基于OpenStack的云开始在各行业规模部署. &quot;OpenStack已经成熟,它走出实验室和概念验证阶段,成为生产级任务负载的主流技术.& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1dKKb.html" rel="bookmark" class="title">Node&period;js中的process&period;nextTick使用实例&lowbar;node&period;js</a>
					<div>
						我已经不记得是在哪里第一次看到process.nextTick这个玩意的调用了,哦,应该是在nodejs官方的process文档里看到的.当时就不理解这东西是干嘛的了,都已经有setTimeout了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKdPRz.html" rel="bookmark" class="title">如何解决发送大量邮件时被服务器拒绝发送的问题？</a>
					<div>
						问题描述 现在有一个电商项目,订单状态改变时要发邮件给客户,但是发送量大了以后,阿里云企业邮箱就把邮件给退回来了,提示内容如图所示,怎么破? 解决方案 本帖最后由 zhaoycchencsd 于 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ14lZb.html" rel="bookmark" class="title">姚金刚：解析2011年八大网络营销手段</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 网络营销的手法很多,常见的有SEO.SEM.网络广告等,大多数时候,实施网络营销需要结合多种有效手段进行配合,才能圆满完成预定目标,当然并非每个方法都适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0Eo8p.html" rel="bookmark" class="title">搞了2年的C&num;，今天听了一个VC&plus;&plus;的视频讲座，发现C&plus;&plus;好强大喔，比C&num;强大多了</a>
					<div>
						问题描述 搞了2年的C#(Winform),今天听了一个VC++的视频讲座(MFC),发现C++好强大喔,比C#强大多了大家怎么看呀 解决方案 解决方案二:c++离硬件比较进,C#比较远不是有专家说过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YW2Rp.html" rel="bookmark" class="title">面对网站降权不用怕  恢复排名有方法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 对于站长而言,做网站大家每天都会去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv01xM.html" rel="bookmark" class="title">IBM发布新数据中心管理软件</a>
					<div>
						11月20日消息,IBM(NYSE:IBM)日前发布了具有突破性的新数据中心管理软件.新技术有望大幅削减运营成本,同时将部署新应用程序的时间由几周缩短到几分钟. IBM推出的全新企业用VMContro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm2RNb.html" rel="bookmark" class="title">纯银：优秀的人才，没一个开口就问&OpenCurlyDoubleQuote;贵司薪水几何&rdquo;（转）</a>
					<div>
						偶然在友秘刷到一条&quot;我开出了天价,为什么还是招不到靠谱的程序员?&quot; 说说我创业这两年对招聘的经验. 创业两年半,最发愁的事情,一是方向,二是招聘.没有三. 招聘靠的主要是三板斧.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn494rb.html" rel="bookmark" class="title">Adobe推出＂Muse＂网站创建工具公共测试版</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 8月16日消息,据国外媒体报道,A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKaYPz.html" rel="bookmark" class="title">再谈 COW、ROW 快照技术</a>
					<div>
						目录 目录 前言 快照与备份的区别 快照技术 增量快照之 COW 增量快照之 row 前言 在经过了一段时间的实践之后,再次回顾 COW/ROW 快照技术的实现原理,温故而知新. 快照与备份的区别 传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9N38Kp.html" rel="bookmark" class="title">VB&period;NET连接数据库失败</a>
					<div>
						问题描述 以下是连接的代码:ImportsSystem.Data.SqlClientPublicClassForm1DimconnAsSqlConnection=NewSqlConnection(&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6qNqWb.html" rel="bookmark" class="title">内忧外患，相宜本草转战香港IPO？今日资本急退</a>
					<div>
						近日本土化妆品企业上海相宜本草化妆品有限公司放弃了上市计划〿/p&gt; 距离相宜本草首次提交招股说明书差不多刚好过去两年,当时拟发行新股不超迿200万股,拟募集资金逿亿元,将用于营销渠道建设和品牌推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZRZWaz.html" rel="bookmark" class="title">asp&period;net中一个奇怪的问题</a>
					<div>
						问题描述 我给一个按钮写了一个添加事键,用到了循环代码如下:protectedvoidButton7_Click(objectsender,EventArgse){inti=0;intj=0;bool ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
